#include "settingsdialog.h"
#include "ui_settingsdialog.h"

SettingsDialog::SettingsDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::SettingsDialog)
{
    ui->setupUi(this);
    ui->layersNumber = Settings::getInstance()->getLayersNumber();
    QString path;
    path << "Path to root folder of the media tree: " << std::endl << Settings::getInstance()->getPathMedia();
    ui->mediaPath->setText(path);

    connect(ui->mediaPatchButton, SIGNAL(clicked()),
            this, SLOT(changeMediaPath()));
    // ToDo: Conectarlo todoooo

    QList<dmxSetting> dmx = Settings::getInstance()->getDmxSettings();
    foreach (it, dmx) {
        QHBoxLayout *layer = new QHBoxLayout;
        QSpinBox *universe = new QSpinBox();
        universe->setValue(it.universe);
        layer->addWidget(universe);

        QSpinBox *address = new QSpinBox();
        address->setValue(it.address);
        layer->addWidget(address);

        ui->layersLayout->addLayout(address);

        connect(universe, SIGNAL(valueChanged(int)),
                this, SLOT(universeChanged(int)));
        connect(address, SIGNAL(valueChanged(int)),
                this, SLOT(addressChnged(int)));
    }
}

SettingsDialog::~SettingsDialog()
{
    delete ui;
}

SettingsDialog::universeChanged(int uni)
{

}

SettingsDialog::addressChanged(int add)
{

}

void SettingsDialog::ChangeMediaPath()
{
    QFileDialog dialog(this);
    dialog.setFileMode(QFileDialog::Directory);
    QStringList fileNames;
    if (!dialog.exec())
        return;
    fileNames = dialog.selectedFiles();
    QString file = fileNames.at(0);
//    MediaLibrary::getInstance()->setPath(file);
    QString desc = tr("Media Path Changed to: %1").arg(file);
    qDebug(desc.toLatin1().constData());
}
